﻿/*
 * XPT2046_TP_Adjust.h
 *
 *  Created on: 2025/02/23
 *      Author: egaono-electronics
 */

#ifndef XPT2046_TP_ADJUST_H_
#define XPT2046_TP_ADJUST_H_

#include "Dev_Conf.h"

#include def_Header_HAL

#include "XPT2046_TP_Access.h"



//--------------------------------------------------------------
#define def_aFlag_Str_Adjust_TP  "AdjTP"  // 調整済みフラグ

#define def_Num_All_Adust_TP  18  // パラメータサイズ :
//              パラメータ + チェックサム : (8 + 1) x 2 = 18 :
//                                          int16_t のデータ
#define def_Num_Param_Adjust_TP    8
                    // サイズ : 8 x 2 = 16 : int16_t のデータ
//--------------------------------------------------------------

//------------------------------------------
// TP調整パラメータ格納位置のオフセット
//------------------------------------------
#define def_Offset_Adjust_TP  0x00E0
//------------------------------------------

//------------------------------------------------------
// Flash Memory上の
//  タッチパネル調整用最小値最大値変数エリアの先頭位置
//------------------------------------------------------
#define def_Pos_Min_Max_TP  0x08
//------------------------------------------------------

// TP調整値書き込み先頭アドレス
#define def_Address_Min_Max_TP  \
                def_Address_Adjust_TP + def_Pos_Min_Max_TP


#define def_Num_Area_Adjust_TP  26
                // TP調整パラメータエリアのサイズ(bytes)



#define def_Detect_TP_OFF  50  // タッチパネルOFF検出カウント数


//--------------------------------------------------
// タッチパネル調整用のタッチ位置表示位置の定義
//--------------------------------------------------
//--------------------------------------------------
// "1" - "4" の番号表示位置
//--------------------------------------------------
// タッチ位置 1
#define def_Position_X_Touch_N_1  0
#define def_Position_Y_Touch_N_1  0

// タッチ位置 2
#define def_Position_X_Touch_N_2  312
#define def_Position_Y_Touch_N_2  0

// タッチ位置 3
#define def_Position_X_Touch_N_3  0
#define def_Position_Y_Touch_N_3  232

// タッチ位置 4
#define def_Position_X_Touch_N_4  312
#define def_Position_Y_Touch_N_4  232


//--------------------------------------------------
// 4 x 4 の四角表示の位置
//--------------------------------------------------
// タッチ位置 1
#define def_Position_X_Touch_S_1  0
#define def_Position_Y_Touch_S_1  0

// タッチ位置 2
#define def_Position_X_Touch_S_2  316
#define def_Position_Y_Touch_S_2  0

// タッチ位置 3
#define def_Position_X_Touch_S_3  0
#define def_Position_Y_Touch_S_3  236

// タッチ位置 4
#define def_Position_X_Touch_S_4  316
#define def_Position_Y_Touch_S_4  236
//--------------------------------------------------



//--------------------------------------------------
// コメント表示位置
//--------------------------------------------------
#define def_Position_X_Comment_1  48
#define def_Position_Y_Comment_1  48


#define def_Position_X_Comment_2  48
#define def_Position_Y_Comment_2  88
//--------------------------------------------------



//--------------------------------------------------
// "Finish" の表示位置
//--------------------------------------------------
#define def_Position_X_Check_Finish  112
#define def_Position_Y_Check_Finish  120
//--------------------------------------------------



//--------------------------------------------------
// 押された番号の表示位置
//--------------------------------------------------
#define def_Position_X_Num  144
#define def_Position_Y_Num  152
//--------------------------------------------------



//--------------------------------------------------
// 調整番号の X と Y の表示位置
//--------------------------------------------------
//----------------------------------------------
// 調整番号 1
//----------------------------------------------
#define def_Pos_X_Num_1_X  16
#define def_Pos_Y_Num_1_X  0

#define def_Pos_X_Num_1_Y  def_Pos_X_Num_1_X
#define def_Pos_Y_Num_1_Y  16
//----------------------------------------------


//----------------------------------------------
// 調整番号 2
//----------------------------------------------
#define def_Pos_X_Num_2_X  320 - 80
#define def_Pos_Y_Num_2_X  def_Pos_Y_Num_1_X

#define def_Pos_X_Num_2_Y  def_Pos_X_Num_2_X
#define def_Pos_Y_Num_2_Y  def_Pos_Y_Num_1_Y
//----------------------------------------------


//----------------------------------------------
// 調整番号 3
//----------------------------------------------
#define def_Pos_X_Num_3_X  def_Pos_X_Num_1_X
#define def_Pos_Y_Num_3_X  240 - 32

#define def_Pos_X_Num_3_Y  def_Pos_X_Num_1_X
#define def_Pos_Y_Num_3_Y  240 - 16
//----------------------------------------------


//----------------------------------------------
// 調整番号 4
//----------------------------------------------
#define def_Pos_X_Num_4_X  def_Pos_X_Num_2_X
#define def_Pos_Y_Num_4_X  def_Pos_Y_Num_3_X

#define def_Pos_X_Num_4_Y  def_Pos_X_Num_2_X
#define def_Pos_Y_Num_4_Y  def_Pos_Y_Num_3_Y
//----------------------------------------------
//--------------------------------------------------



//----------------------------------------------
// 調整位置 1 - 4 の判定の定義
//----------------------------------------------
// 1 - 4 のどれが押されたかを判定する。
//----------------------------------------------

// 調整位置 1
#define def_Adjust_X_1    500
#define def_Adjust_Y_1    500


// 調整位置 2
#define def_Adjust_X_2    3500
#define def_Adjust_Y_2    500


// 調整位置 3
#define def_Adjust_X_3    500
#define def_Adjust_Y_3    3500


// 調整位置 4
#define def_Adjust_X_4    3500
#define def_Adjust_Y_4    3500

//----------------------------------------------



#define def_Repeat_TP_Adjust  16
                        // 位置調整のための繰り返し回数
#define def_Ave_TP_Adjust      8  // 位置調整の平均回数



// Y位置補正係数 +Alpha
#define def_Tilt_TP_Alpha  0


// X,Y表示位置
#define def_Position_X_TP_X_Item     96    // X座標 X項目表示
#define def_Position_Y_TP_X_Item    204    // Y座標 X項目表示

#define def_Position_X_TP_Y_Item    \
                def_Position_X_TP_X_Item  // X座標 Y項目表示
#define def_Position_Y_TP_Y_Item    \
            (def_Position_Y_TP_X_Item + 20)  // Y座標 Y項目表示


#define def_Position_X_TP_X_Value  \
        (def_Position_X_TP_X_Item + 16 * 3)  // X座標 X位置表示
#define def_Position_Y_TP_X_Value  \
                def_Position_Y_TP_X_Item   // Y座標 X位置表示

#define def_Position_X_TP_Y_Value  \
                def_Position_X_TP_X_Value  // X座標 Y位置表示
#define def_Position_Y_TP_Y_Value  \
                def_Position_Y_TP_Y_Item   // Y座標 Y位置表示



//------------------------------------------------------
// タッチパネル位置調整用パラメータの構造体
//------------------------------------------------------
struct sParam_Adjust_TP{
  //--------------------------------------------
  // XPT2046初期化フラグ
  //--------------------------------------------
  //    0 : 未初期化
  //    1 : 初期化済み
  //--------------------------------------------
  int16_t int16_Initialize_XPT2046;
  //--------------------------------------------



  //------------------------------------------------------------
  // タッチパネルの位置調整用のXY検出値
  //------------------------------------------------------------
  int16_t int16_Adjust_TP_X_1;  // タッチパネル調整位置_X_1
  int16_t int16_Adjust_TP_Y_1;  // タッチパネル調整位置_Y_1

  int16_t int16_Adjust_TP_X_2;  // タッチパネル調整位置_X_2
  int16_t int16_Adjust_TP_Y_2;  // タッチパネル調整位置_Y_2

  int16_t int16_Adjust_TP_X_3;  // タッチパネル調整位置_X_3
  int16_t int16_Adjust_TP_Y_3;  // タッチパネル調整位置_Y_3

  int16_t int16_Adjust_TP_X_4;  // タッチパネル調整位置_X_4
  int16_t int16_Adjust_TP_Y_4;  // タッチパネル調整位置_Y_4
  //------------------------------------------------------------



  //------------------------------------------------------------
  // タッチパネル調整用XY最大最小値
  //------------------------------------------------------------
  // 最小値
  int16_t int16_Adjust_TP_X_MIN;  // タッチパネル調整位置_X_最小値
  int16_t int16_Adjust_TP_Y_MIN;  // タッチパネル調整位置_Y_最小値


  // 最大値
  int16_t int16_Adjust_TP_X_MAX;  // タッチパネル調整位置_X_最大値
  int16_t int16_Adjust_TP_Y_MAX;  // タッチパネル調整位置_Y_最大値
  //------------------------------------------------------------


  //------------------------------------------------------------
  //タッチパネル調整用パラメータ
  //------------------------------------------------------------
  uint8_t uint8_Num_Pos;  // 調整位置番号
  int16_t int16_Count_Repeat;  // 繰り返し回数カウンタ
  int16_t int16_Count_Repeat_Finish;
                        // 終了チェック用繰り返し回数カウンタ
  int16_t int16_Pos_Ave;  // 平均値用データ格納位置
  uint16_t uint16_aPos_Buf_X[(int16_t)def_Ave_TP_Adjust];
                                    // X位置データ格納バッファ
  uint16_t uint16_aPos_Buf_Y[(int16_t)def_Ave_TP_Adjust];
                                    // Y位置データ格納バッファ
  int16_t int16_Adjust_TP_X;  // X位置
  int16_t int16_Adjust_TP_Y;  // Y位置
  //------------------------------------------------------------
};


//----------------------------------------------------------
// タッチパネルの位置調整
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Adjust_TP(uint8_t *puint8_JobNum,
        struct sParam_Adjust_TP *pstructParam_Adjust_TP,
        struct sParam_Position_TP *pstructParam_Position_TP);



//----------------------------------------------------------
// タッチパネル調整用タッチ位置表示
//----------------------------------------------------------
// タッチ位置番号 1 - 4 を反転表示する。: コーナー 4箇所
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Draw_Adjust_Position(uint8_t *puint8_JobNum);



//----------------------------------------------------------
// タッチパネルのXY位置表示
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// uint16_t uint16_X : X位置
// uint16_t uint16_Y : Y位置

// uint16_t uint16_Pos_X_X : X表示位置 X
// uint16_t uint16_Pos_Y_X : X表示位置 Y

// uint16_t uint16_Pos_X_Y : Y表示位置 X
// uint16_t uint16_Pos_Y_Y : Y表示位置 Y


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Display_TP_XY(uint8_t *puint8_JobNum,
            uint16_t uint16_X, uint16_t uint16_Y,
            uint16_t uint16_Pos_X_X, uint16_t uint16_Pos_Y_X,
            uint16_t uint16_Pos_X_Y, uint16_t uint16_Pos_Y_Y);



//----------------------------------------------------------
// タッチ位置番号 1 - 4 と x, y 位置を表示する。
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//    2 : 該当なし
//----------------------------------------------------------
int16_t Draw_Num_Pos(uint8_t *puint8_JobNum,
        struct sParam_Adjust_TP *pstructParam_Adjust_TP,
        struct sParam_Position_TP *pstructParam_Position_TP);



//----------------------------------------------------------
// XY調整位置の判定とセット
//----------------------------------------------------------
// 引数;
// uint16_t uint16_Position_TP_X : X位置
// uint16_t uint16_Position_TP_Y : Y位置

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値;
//   -2 : 繰り返し回数が達していない
//    0 : OK終了
//    2 : 該当なし
//----------------------------------------------------------
int16_t Check_Pos_XY(uint16_t uint16_Position_TP_X,
            uint16_t uint16_Position_TP_Y,
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// 調整位置チェック
//----------------------------------------------------------
// 引数;
// uint8_t uint8_Num : 調整位置番号

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値;
//   -2 : 繰り返し回数が達していない。
//    0 : OK終了
//----------------------------------------------------------
int16_t Check_Adust_Position(uint8_t uint8_Num,
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネルの調整位置番号とXY位置表示
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Print_TP_Num_XY(uint8_t *puint8_JobNum,
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネル調整処理
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Execute_Adjust_TP(uint8_t *puint8_JobNum,
        struct sParam_Adjust_TP *pstructParam_Adjust_TP,
        struct sParam_Position_TP *pstructParam_Position_TP);



//----------------------------------------------------------
// タッチパネル調整終了チェック
//----------------------------------------------------------
// タッチ位置番号 1 - 4 : コーナー 4箇所を全てタッチした後、
// 調整終了位置が押されたことをチェックする。
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ


// 戻り値;
//   -2 : 処理番号をデクリメント :
//                          Touch Panel 位置検出処理に戻る。
//   -1 : 処理中 : "Finish" 表示中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Check_Finish_Adjust_TP(uint8_t *puint8_JobNum,
        struct sParam_Adjust_TP *pstructParam_Adjust_TP,
        struct sParam_Position_TP *pstructParam_Position_TP);



//----------------------------------------------------------
// タッチパネルの位置情報保存
//----------------------------------------------------------
// 引数;
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値;
//    なし
//----------------------------------------------------------
void Save_Param_Pos_TP(
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネル調整値をFlash Memoryから読み込む。
//----------------------------------------------------------
// 引数;
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値:
//    0 : OK
//    1 : NG
//----------------------------------------------------------
int16_t Load_Adjust_TP(
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネル調整値をFlash Memoryに保存する。
//----------------------------------------------------------
// 引数;
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値:
//    0 : OK
//    1 : NG
//----------------------------------------------------------
int16_t Save_Adjust_TP(
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネルの位置調整
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t Transact_Adjust_TP(uint8_t *puint8_JobNum,
        struct sParam_Position_TP *pstructParam_Position_TP,
        struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネル位置調整用パラメータの構造体の宣言
//----------------------------------------------------------
extern struct sParam_Adjust_TP GLB_structParam_Adjust_TP;



#endif /* XPT2046_TP_ADJUST_H_ */
