﻿/*
 * XPT2046_TP_Correct_Pos.h
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#ifndef XPT2046_TP_CORRECT_POS_H_
#define XPT2046_TP_CORRECT_POS_H_

#include "Dev_Conf.h"

#include def_Header_HAL

#include "XPT2046_TP_Adjust.h"



//----------------------------------------------------------
// タッチパネルの補正係数算出
//----------------------------------------------------------
// 引数;
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値;
//    なし
//----------------------------------------------------------
void Calc_Correction_Coefficent_Pos_TP_Y(
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



//----------------------------------------------------------
// タッチパネルのY位置補正値算出
//----------------------------------------------------------
// 引数;
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ


// 戻り値:
//    Y位置補正値
//----------------------------------------------------------
uint16_t Correct_Pos_TP_Y(
            struct sParam_Adjust_TP *pstructParam_Adjust_TP);



// Y位置補正係数
extern float GLB_flt_Tilt_TP_Y;    // 水平方向のゆがみ率
extern float GLB_flt_Tilt_V_TP_Y;  // 垂直方向のゆがみ率



#endif /* XPT2046_TP_CORRECT_POS_H_ */
