﻿/*
 * MSP2807_Test_TP_Detect.h
 *
 *  Created on: 2025/02/25
 *      Author: egaono-electronics
 */

#ifndef MSP2807_TEST_TP_DETECT_H_
#define MSP2807_TEST_TP_DETECT_H_

#include "Dev_Conf.h"

#include def_Header_HAL

#include "XPT2046_TP_Adjust.h"
#include "XPT2046_TP_Detect.h"



//--------------------------------------------------------------
// Test TP SW Functionの値を設定
//--------------------------------------------------------------
// 引数:
// struct sParam_TP_SW *pstructParam_TP_SW :
//          タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//    なし
//--------------------------------------------------------------
void Set_Test_TP_SW_Value_Function(
                    struct sParam_TP_SW *pstructParam_TP_SW);



//--------------------------------------------------------------
// Test TP SW Upper case/Lower caseの値を設定 : UL
//--------------------------------------------------------------
// 引数:
// int16_t int16_Sel : 表示選択
//    0 : 表示 : ASCII
//    1 : 消去 : HEX

// struct sParam_TP_SW *pstructParam_TP_SW :
//          タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//    なし
//--------------------------------------------------------------
void Set_Test_TP_SW_Value_Upper_Lower(int16_t int16_Sel,
                        struct sParam_TP_SW *pstructParam_TP_SW);



//--------------------------------------------------------------
// Test TP SWの表示位置と検出位置をセット
//--------------------------------------------------------------
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//              タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_TP_SW *pstructParam_TP_SW :
//              タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//    なし
//--------------------------------------------------------------
void Set_Test_TP_SW_Position(
                struct sParam_Adjust_TP *pstructParam_Adjust_TP,
                struct sParam_TP_SW *pstructParam_TP_SW);



#endif /* MSP2807_Test_TP_DETECT_H_ */
