/*
 * MSP2807_Test_TP_Key_In.h
 *
 *  Created on: 2025/02/25
 *      Author: egaono-electronics
 */

#ifndef MSP2807_TEST_TP_KEY_IN_H_
#define MSP2807_TEST_TP_KEY_IN_H_

#include "Dev_Conf.h"

#include def_Header_HAL

#include "XPT2046_TP_Key_In.h"

#include "Color_Code.h"

#include "XPT2046_TP_Adjust.h"
#include "XPT2046_TP_Detect.h"



//--------------------------------------------------------------
// Test TP SWデータ入力
//--------------------------------------------------------------
// 引数：
// uint8_t *puint8_JobNum : 処理番号が格納される変数のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ

// struct sParam_TP_SW *pstructParam_TP_SW :
//          タッチパネルスイッチ用パラメータの構造体のポインタ

// uint16_t uint16_Offset_Draw_Y : 表示位置オフセット Y

// int16_t int16_Size_Data_Buffer : Data Buffer Size

// int16_t *pint16_Size_Input_Data :
//                  入力データサイズを格納する変数のポインタ
// uint8_t *puint8_aData_Buffer : Dataを格納するBufferのポインタ


// 戻り値：
//   -2 : Block, Sequence, Type 変更
//   -1 : 処理中
//    0 : OK終了 : Enter
//    1 : NG終了
//--------------------------------------------------------------
int16_t Input_Data_Test_TP_SW(uint8_t *puint8_JobNum,
            struct sParam_Position_TP *pstructParam_Position_TP,
            struct sParam_TP_SW *pstructParam_TP_SW,
                              uint16_t uint16_Offset_Draw_Y,
                              int16_t int16_Size_Data_Buffer,
                              int16_t *pint16_Size_Input_Data,
                              uint8_t *puint8_aData_Buffer);



//--------------------------------------------------------------
// Test タッチパネル上のアルファニューメリックデータ入力
//--------------------------------------------------------------
// 引数：
// uint8_t *puint8_JobNum : 処理番号が格納される変数のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//              タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_TP_SW *pstructParam_TP_SW :
//              タッチパネルスイッチ用パラメータの構造体のポインタ

// uint16_t *puint16_Num_Data_Input :
//                      入力データ数を格納するWorkのポインタ
// uint8_t *puint8_aData : Dataを格納するBufferのポインタ


// 戻り値：
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//--------------------------------------------------------------
int16_t Input_Data_AN_Test_TP(uint8_t *puint8_JobNum,
                struct sParam_Position_TP *pstructParam_Position_TP,
                struct sParam_Adjust_TP *pstructParam_Adjust_TP,
                struct sParam_TP_SW *pstructParam_TP_SW,
                uint16_t *puint16_Num_Data_Input,
                uint8_t *puint8_aData);



//--------------------------------------------------------------
// Test データ入力画面表示
//--------------------------------------------------------------
// 引数：
// uint8_t *puint8_JobNum : 処理番号が格納される変数のポインタ


// 戻り値：
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//--------------------------------------------------------------
int16_t Print_Screen_Test_Input_Data(uint8_t *puint8_JobNum);



#endif /* MSP2807_TEST_TP_KEY_IN_H_ */
